define(["util/classutils","bionic/util/frame_monitor","bionic/util/maths_extended","bionic/util/mouse_manager","bionic/util/keyboard_manager","bionic/util/sound_sprite_manager","bionic/util/sound_file_manager","bionic/sounds","bionic/sprites","bionic/instructions","bionic/game_screen","TweenMax","easeljs","bionic/size_adjuster"],function(classUtils,FrameMonitor,MathsExtended,MouseManager,KeyboardManager,SoundSpriteManager,SoundFileManager,Sounds,SpriteManager,Instructions,Game,TweenMax,easeljs,SizeAdjuster){"use strict";return classUtils.create({state:'',gameCanvas:null,maths:null,frameMonitor:null,sprites:null,mouse:null,preloader:null,instructions:null,game:null,current_level:0,currentState:null,sound_on:true,firstPlay:true,init:function()
{var self=this;self.gameCanvas=new createjs.Stage("game_canvas");self.sprites=window.preloader.sprites;self.frameMonitor=new FrameMonitor();self.frameMonitor.monitor();self.maths=new MathsExtended();self.mouse=new MouseManager(self.gameCanvas);self.size_adjuster=new SizeAdjuster();var sounds=new Sounds();$.ajax({type:"GET",url:"data.xml"+(window.debug?"?noCache="+new Date().getTime():""),dataType:"xml",success:function(result)
{var xml=$(result);var game_id=xml.children('game').children('name').text();game_id=game_id.replace(/[^\w\s]|_/g,"").replace(/\s+/g," ").toLowerCase().replace(/ /g,"_");xml.children('game').children('items').children('item').each(function(){if($(this).find("type").text()=="sound")
{var id=$(this).find("id").text();var sprite_id;var file_id;if(id=="title_music")
{sprite_id="bgm";file_id="title";}
else if(id=="game_music")
{sprite_id="bgm";file_id="game";}
else if(id=="woo")
{sprite_id="woo";file_id="sound";}
for(var i=0;i<sounds.sprites.length;i++)
{if(sounds.sprites[i].id==sprite_id)
{for(var j=0;j<sounds.sprites[i].files.length;j++)
{if(sounds.sprites[i].files[j].id==file_id)
{var mp3_file=$(this).find("content").find("mp3").text();var ogg_file=$(this).find("content").find("ogg").text();if(mp3_file!=""||ogg_file!="")
{if(mp3_file!="")
sounds.sprites[i].files[j].mp3=mp3_file;else
sounds.sprites[i].files[j].mp3="";if(ogg_file!="")
sounds.sprites[i].files[j].ogg=ogg_file;else
sounds.sprites[i].files[j].ogg="";}}}}}}});self.create(sounds);}});},create:function(sounds)
{var self=this;self.sound_managers={};for(var i in sounds.sprites)
{if(sounds.sprites[i].sprites!=null)
self.sound_managers[sounds.sprites[i].id]=new SoundSpriteManager(sounds.sprites[i],sounds.sprites[i].id,sounds.sprites[i].android,window.isAndroid);else if(sounds.sprites[i].files!=null)
self.sound_managers[sounds.sprites[i].id]=new SoundFileManager(sounds.sprites[i],sounds.sprites[i].id,true,sounds.sprites[i].android,window.isAndroid);}
createjs.Ticker.setFPS(window.fps);createjs.Ticker.addEventListener("tick",function(){self.update();});createjs.Touch.enable(self.gameCanvas);},preload:function()
{var self=this;var assets=[];for(var i in assets)
{assets[i]=window.base_url+assets[i];}
for(i in self.sprites.sheets)
{var ignore=self.sprites.sheets[i].ignore_on_load;if(!ignore)
assets.push(self.sprites.get_data(i).sheet);}
self.preloader=window.preloader;setTimeout(function(){self.preloader.preload(assets);},1150);self.updateState("preload");},startGame:function()
{var self=this;self.current_level=1;if(self.firstPlay==true)
{self.updateState("instructions");self.firstPlay=false;}else{self.updateState("game");}},updateState:function(state)
{var self=this;self.state=state;if(self.currentState!=null)
{self.currentState.hide();}
if(self.state=="preload")
{self.currentPage=self.preloader;}else if(self.state=="instructions")
{if(self.instructions==null)
{self.instructions=new Instructions();}
self.currentPage=self.instructions;}else if(self.state=="game")
{if(self.game==null)
{self.game=new Game();}
self.currentPage=self.game;}
else{console.log("New State not found");}
self.currentPage.show();},game_instructions_show:function()
{var self=this;self.currentPage=self.instructions;self.currentPage.show_from_game();},game_instructions_hide:function()
{var self=this;self.currentPage.hide();self.currentPage=self.game;self.currentPage.show_active_game_from_instructions();},back_to_title:function()
{var self=this;self.currentPage.hide();self.currentPage=self.preloader;self.currentPage.show_title();},update:function()
{var self=this;self.currentPage.update();},update_dimensions:function(_width,_height)
{var self=this;self.size_adjuster.update((944-_width)/2,(577-_height)/2);}});});