define(["util/classutils"],function(classUtils){"use strict";return classUtils.create({init:function()
{},rads:function(degrees)
{return degrees*(Math.PI/180);},degs:function(radians)
{return radians*(180/Math.PI);},rand:function(min,max)
{return min+(Math.random()*(max-min));},rand_int:function(min,max)
{return Math.round(min+(Math.random()*(max-min)));},get_hypotenuse:function(x1,x2,y1,y2)
{var x_distance=Math.abs(x1-x2);var y_distance=Math.abs(y1-y2);return Math.sqrt(Math.pow(x_distance,2)+Math.pow(y_distance,2));},get_angle_to_point:function(start_x,target_x,start_y,target_y)
{var angle_in_radians=Math.atan2(target_y-start_y,target_x-start_x);if(angle_in_radians<0)
{angle_in_radians=(2*Math.PI)+angle_in_radians;}
return angle_in_radians;},get_increment_for_angle:function(radians,distance)
{return{x:-1*(-Math.sin(radians)*distance),y:-1*(Math.cos(radians)*distance)};},get_rotation_increment:function(start_radians,end_radians)
{return Math.atan2(Math.sin(end_radians-start_radians),Math.cos(end_radians-start_radians));},apply_angle_to_points:function(rads,x,y)
{var tx=Math.cos(rads)*x-Math.sin(rads)*y;var ty=Math.sin(rads)*x+Math.cos(rads)*y;return{x:tx,y:ty};},shuffle_array:function(o){for(var j,x,i=o.length;i;j=Math.floor(Math.random()*i),x=o[--i],o[i]=o[j],o[j]=x);return o;},get_points_of_line:function(t,points)
{var self=this;var x=0;var y=0;var n=points.length-1;var factn=self.factoral(n);for(var i=0;i<=n;i++)
{var b=factn/(self.factoral(i)*self.factoral(n-i));var k=Math.pow(1-t,n-i)*Math.pow(t,i);x+=b*k*points[i].x;y+=b*k*points[i].y;}
var obj={x:x,y:y};return obj;},factoral:function(value)
{if(value==0)
return 1;var total=value;while(--value>1)
total*=value;return total;},});});